//
// UserAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class UserAPI {
    /**

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiUserGetUserGet(completion: @escaping ((_ data: UserResponseModelArrayResponseModel?,_ error: Error?) -> Void)) {
        apiUserGetUserGetWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - GET /api/User/GetUser
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "Email" : "Email",
    "Joining" : "2000-01-23T04:56:07.000+00:00",
    "Id" : "Id",
    "Name" : "Name"
  }, {
    "Email" : "Email",
    "Joining" : "2000-01-23T04:56:07.000+00:00",
    "Id" : "Id",
    "Name" : "Name"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]

     - returns: RequestBuilder<UserResponseModelArrayResponseModel> 
     */
    open class func apiUserGetUserGetWithRequestBuilder() -> RequestBuilder<UserResponseModelArrayResponseModel> {
        let path = "/api/User/GetUser"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserResponseModelArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**

     - parameter _id: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiUserIdDelete(_id: Int, completion: @escaping ((_ data: Void?,_ error: Error?) -> Void)) {
        apiUserIdDeleteWithRequestBuilder(_id: _id).execute { (response, error) -> Void in
            if error == nil {
                completion((), error)
            } else {
                completion(nil, error)
            }
        }
    }


    /**
     - DELETE /api/User/{id}
     - 

     - parameter _id: (path)  

     - returns: RequestBuilder<Void> 
     */
    open class func apiUserIdDeleteWithRequestBuilder(_id: Int) -> RequestBuilder<Void> {
        var path = "/api/User/{id}"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**

     - parameter _id: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiUserIdPut(_id: Int, completion: @escaping ((_ data: Void?,_ error: Error?) -> Void)) {
        apiUserIdPutWithRequestBuilder(_id: _id).execute { (response, error) -> Void in
            if error == nil {
                completion((), error)
            } else {
                completion(nil, error)
            }
        }
    }


    /**
     - PUT /api/User/{id}
     - 

     - parameter _id: (path)  

     - returns: RequestBuilder<Void> 
     */
    open class func apiUserIdPutWithRequestBuilder(_id: Int) -> RequestBuilder<Void> {
        var path = "/api/User/{id}"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**

     - parameter body: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiUserLoginPost(body: LoginRequestModel? = nil, completion: @escaping ((_ data: Void?,_ error: Error?) -> Void)) {
        apiUserLoginPostWithRequestBuilder(body: body).execute { (response, error) -> Void in
            if error == nil {
                completion((), error)
            } else {
                completion(nil, error)
            }
        }
    }


    /**
     - POST /api/User/Login
     - 

     - parameter body: (body)  (optional)

     - returns: RequestBuilder<Void> 
     */
    open class func apiUserLoginPostWithRequestBuilder(body: LoginRequestModel? = nil) -> RequestBuilder<Void> {
        let path = "/api/User/Login"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**

     - parameter body: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiUserRegisterUserPost(body: UserRegistrationRequest? = nil, completion: @escaping ((_ data: UserResponseModelResponseModel?,_ error: Error?) -> Void)) {
        apiUserRegisterUserPostWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - POST /api/User/RegisterUser
     - 

     - examples: [{contentType=application/json, example={
  "Data" : {
    "Email" : "Email",
    "Joining" : "2000-01-23T04:56:07.000+00:00",
    "Id" : "Id",
    "Name" : "Name"
  },
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter body: (body)  (optional)

     - returns: RequestBuilder<UserResponseModelResponseModel> 
     */
    open class func apiUserRegisterUserPostWithRequestBuilder(body: UserRegistrationRequest? = nil) -> RequestBuilder<UserResponseModelResponseModel> {
        let path = "/api/User/RegisterUser"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<UserResponseModelResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
